﻿using BS.MonoBehaviours;
using UnboundLib.Cards;
using UnityEngine;

namespace BS.Cards
{
    class Brimstone : CustomCard
    {
        public override void SetupCard(CardInfo cardInfo, Gun gun, ApplyCardStats cardStats, CharacterStatModifiers statModifiers, Block block)
        {
            cardInfo.allowMultiple = true;
            gun.unblockable = true;
            gun.reloadTimeAdd = 5f;
            gun.damage = 50f;
            gun.dmgMOnBounce = 1.5f;
            gun.projectileSpeed = 10f;
            statModifiers.health = 0.2f;

            var explosiveBullet = (GameObject)Resources.Load("0 cards/Explosive bullet");
            var a_Explosion = explosiveBullet.GetComponent<Gun>().objectsToSpawn[0].effect;
            var explo = Instantiate(a_Explosion);
            explo.transform.position = new Vector3(1000, 0, 0);
            explo.hideFlags = HideFlags.HideAndDontSave;
            explo.name = "customExplo";
            DestroyImmediate(explo.GetComponent<RemoveAfterSeconds>());
            var explodsion = explo.GetComponent<Explosion>();
            explodsion.force = 1f;

            var obj = new GameObject("rocket_projectile", typeof(BulletBase));

            gun.objectsToSpawn = new[]
            {
                new ObjectsToSpawn
                {
                    effect = explo,
                    normalOffset = 0.1f,
                    numberOfSpawns = 1,
                    scaleFromDamage = 0.0001f,
                    scaleStackM = 0.7f,
                    scaleStacks = true,
                },
                new ObjectsToSpawn
                {
                    AddToProjectile = obj,
                    scaleFromDamage = 1f
                }
            };

        }
        public override void OnAddCard(Player player, Gun gun, GunAmmo gunAmmo, CharacterData data, HealthHandler health, Gravity gravity, Block block, CharacterStatModifiers characterStats)
        {
            //gun.soundShotModifier = ;
            //gun.soundImpactModifier = ;
            gun.attackSpeed += 5f;
            gun.gravity = 0f;
            gun.drag = 0f;
            gunAmmo.maxAmmo += 10;
            gun.projectileColor = Color.red;
            gun.timeBetweenBullets = .02f;
            player.gameObject.AddComponent<BSmono>();
        }
        public override void OnRemoveCard(Player player, Gun gun, GunAmmo gunAmmo, CharacterData data, HealthHandler health, Gravity gravity, Block block, CharacterStatModifiers characterStats)
        {
        }
        protected override string GetTitle()
        {
            return "BRIMSTONE";
        }
        protected override string GetDescription()
        {
            return "BLOOD LASER BARRAGE";
        }
        protected override GameObject GetCardArt()
        {
            return BS.ArtAsset.LoadAsset<GameObject>("brart");
        }
        protected override CardInfo.Rarity GetRarity()
        {
            return CardInfo.Rarity.Rare;
        }
        protected override CardInfoStat[] GetStats()
        {
            return new CardInfoStat[]
            {

            };
        }
        protected override CardThemeColor.CardThemeColorType GetTheme()
        {
            return CardThemeColor.CardThemeColorType.DestructiveRed;
        }
        public override string GetModName()
        {
            return "BS";
        }
    }
}
